#!/bin/bash
cmd=./xgb.py
ftrain=data/new_train.csv
ftest=data/new_test.csv
tstamp=`date +%Y%m%d`
odir=results
mkdir -p $odir
for seed in 5 9 17;
do
    cat params.json | sed "s,12345,$seed,g" > /tmp/params.json
    echo "$cmd --ftrain=$ftrain --ftest=$ftest --params=/tmp/params.json --date=Original_Quote_Date --fout=$odir/xgb_seed${seed}.csv 2>&1 1>& $odir/xgb_seed${seed}.log < /dev/null"
    $cmd --ftrain=$ftrain --ftest=$ftest --params=/tmp/params.json --date=Original_Quote_Date --fout=$odir/xgb_seed${seed}.csv 2>&1 1>& $odir/xgb_seed${seed}.log < /dev/null
    gzip $odir/xgb_seed${seed}.csv
done
